import { Injectable } from '@angular/core';
import { Resolve, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
import { Observable } from 'rxjs';
import RedeemableAction from '../models/redeemable-action';
import RedeemableActionService from '../services/redeemable-action.service';

@Injectable({ providedIn: 'root' })
export default class RedeemableActionResolver implements Resolve<RedeemableAction[]> {
  constructor(private service: RedeemableActionService) { }

  resolve(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): Observable<RedeemableAction[]> {
    return this.service.fetch();
  }
}