import { Injectable } from "@angular/core";
import { Subject } from "rxjs"

@Injectable({
  providedIn: 'root'
})
export default class EventService {
  private subject = new Subject();

  emit(eventName: string, payload: any) {
    this.subject.next({ eventName, payload })
  }

  listen(eventName: string, callback: (event: any) => void) {
    return this.subject.asObservable().subscribe((next: any) => {
      if (eventName == next.eventName) {
        callback(next.payload)
      }
    })
  }
}